'From Squeak2.9alpha of 13 June 2000 [latest update: #2875] on 20 October 2000 at 12:34:51 am'!
"Change Set:		chicken
Date:			20 October 2000
Author:			Michael Rueger

A little cursor watcher :-)
Based on the Smalltalk-X implementation by Claus Gittinger and a result of Camp Smalltalk at OOPSLA 2000.
Launch with
	ChickenEyes new openInWorld

Get rid of it by shift-clicking on it."!

ImageMorph subclass: #AnimatedImageMorph
	instanceVariableNames: 'lastImageTime timePerFrame loop currentImageIndex imageSequence endOfFrameNotification endOfSequenceNotification '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Demo'!
AnimatedImageMorph subclass: #ChickenEyes
	instanceVariableNames: 'nextActionTime nextActions random hiding '
	classVariableNames: 'BlinkImages ComeImages FwdImage HoleImages LookImages PickImages '
	poolDictionaries: ''
	category: 'Morphic-Demo'!
ChickenEyes class
	instanceVariableNames: ''!

!AnimatedImageMorph methodsFor: 'initialize' stamp: 'mir 10/20/2000 00:06'!
initialize
	super initialize.
	currentImageIndex := 0.
	loop := false.
	timePerFrame := 250.! !

!AnimatedImageMorph methodsFor: 'stepping' stamp: 'mir 10/18/2000 18:24'!
step
	(self isAnimating
	 and: [(Time millisecondsSince: self lastImageTime) > self timePerFrame])
		ifTrue: [self stepToNextFrame]
"		ifFalse: [(Time millisecondsSince: self lastImageTime) printString displayAt: 0@0]"! !

!AnimatedImageMorph methodsFor: 'stepping' stamp: 'mir 10/19/2000 22:07'!
stepTime
	^self timePerFrame! !

!AnimatedImageMorph methodsFor: 'stepping' stamp: 'mir 10/18/2000 18:22'!
stepToNextFrame
	self currentImageIndex = self imageSequence size
		ifTrue: [
			self loop
				ifTrue: [currentImageIndex := 1]
				ifFalse: [
					currentImageIndex := 0.
					^self signalEndOfSequence]].
	self signalEndOfFrame.
	self image: self currentImage.
 	currentImageIndex := currentImageIndex + 1.
	self updateLastImageTime.
! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 14:52'!
endOfFrameNotification
	^endOfFrameNotification ifNil: [[:frameNumber | ] ]! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 14:53'!
endOfFrameNotification: anAction
	endOfFrameNotification _ anAction! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 14:53'!
endOfSequenceNotification
	^endOfSequenceNotification ifNil: [[ ] ]! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 14:53'!
endOfSequenceNotification: anAction
	endOfSequenceNotification _ anAction! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 18:12'!
imageSequence: images timePerFrame: deltaTime
	imageSequence _ images.
	timePerFrame _ deltaTime.
	self startSequence! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 18:08'!
loop
	^loop! !

!AnimatedImageMorph methodsFor: 'accessing' stamp: 'mir 10/18/2000 18:08'!
loop: aBoolean
	loop := aBoolean! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 14:57'!
currentImage
	^imageSequence at: currentImageIndex! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 14:57'!
currentImageIndex
	^currentImageIndex! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 15:02'!
imageSequence
	^imageSequence! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 17:26'!
isAnimating
	^self currentImageIndex > 0! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 15:00'!
lastImageTime
	^lastImageTime! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 15:18'!
signalEndOfFrame
	self endOfFrameNotification value: self currentImageIndex! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 15:18'!
signalEndOfSequence
	self endOfSequenceNotification value! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 18:22'!
startSequence
	currentImageIndex := 1.
	self updateLastImageTime.
	self image: self currentImage.
! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 18:14'!
timePerFrame
	^timePerFrame! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 10/18/2000 18:13'!
updateLastImageTime
	lastImageTime := Time millisecondClockValue! !


!ChickenEyes methodsFor: 'event handling' stamp: 'mir 10/20/2000 00:26'!
handleMouseDown: evt
	evt redButtonPressed
		ifTrue: [evt shiftPressed
			ifTrue: [self delete]
			ifFalse: [self startPicking]]
		ifFalse: [self goAwayAction]! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/20/2000 00:04'!
animationAction
	| nextAction |
	Time millisecondClockValue > self nextActionTime
		ifFalse: [^self].
	nextAction := self nextAnimationAction.
	nextActionTime _ self nextAnimationActionTime.
	self perform: nextAction first! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/19/2000 23:40'!
blinkAction
	self imageSequence: self class blinkingSequence timePerFrame: 100.
	self endOfSequenceNotification: [self followCursor]! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/19/2000 23:49'!
cameInAction
	self hiding: false.
! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/20/2000 00:18'!
comingInAction
	self position: InputSensor default cursorPoint.
	self comeToFront.
	self show.
	self imageSequence: self class comeInSequence timePerFrame: 100.
	self endOfSequenceNotification: [self cameInAction]! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/19/2000 23:51'!
followCursor
	| cursorPosition myCenter angle imageIndex newImage diff |
	self hiding
		ifTrue: [^self].
	cursorPosition := InputSensor default cursorPoint.
	myCenter := self bounds center.
	diff _ cursorPosition - myCenter.
	diff r < 20
		ifTrue: [^self].
	angle := (diff *(1@-1)) degrees.
	imageIndex := angle // (360 // self class lookImages size) + 1.
	newImage := self class lookImages at: imageIndex.
	newImage ~~ self image
		ifTrue: [self image: newImage].
	self randomNextAction! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/19/2000 23:52'!
goAwayAction
	self hiding: true.
	self resetActions.
	self imageSequence: self class goAwaySequence timePerFrame: 100.
	self endOfSequenceNotification: [self hideForAWhile]! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/20/2000 00:23'!
hideForAWhile
	self hide.
	self nextAnimationAction: #comingInAction after: (self random nextInt: 30000)! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/20/2000 00:24'!
randomNextAction
	| nextActionPicker nextRandomAction |
	nextActionPicker := self random nextInt: 100.
	nextRandomAction := nextActionPicker < 90
		ifTrue: [#yourself]
		ifFalse: [nextActionPicker < 99
			ifTrue: [#blinkAction]
			ifFalse: [#goAwayAction]].
	self nextAnimationAction: nextRandomAction after: 200! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/19/2000 23:32'!
startAnimation

	self nextAnimationAction: #comingInAction after: 0! !

!ChickenEyes methodsFor: 'animation' stamp: 'mir 10/19/2000 22:17'!
startPicking
	self imageSequence: self class pickSequence , self class pickSequence , self class pickSequence timePerFrame: 200.
	self endOfSequenceNotification: [self followCursor]! !

!ChickenEyes methodsFor: 'initialize-release' stamp: 'mir 10/20/2000 00:19'!
initialize
	super initialize.
	nextActions := OrderedCollection new: 3.
	nextActionTime := 0.
	self hiding: true.
	self on: #mouseDown send: #handleMouseDown: to: self.
	random := Random new.
"	self on: #mouseStillDown send: #followCursor to: self."
	self startAnimation! !

!ChickenEyes methodsFor: 'stepping' stamp: 'mir 10/19/2000 18:16'!
step
	self animationAction.
	super step! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/19/2000 23:46'!
hiding
	^hiding! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/19/2000 23:46'!
hiding: aBoolean
	hiding := aBoolean! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/19/2000 19:28'!
nextActionTime
	^nextActionTime! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/19/2000 22:19'!
nextAnimationAction
	nextActions isEmptyOrNil
		ifTrue: [^#(#followCursor 0)].
	^nextActions removeFirst! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/20/2000 00:09'!
nextAnimationAction: anAction after: delta
	nextActions add: (Array with: anAction with: delta).
	nextActions size = 1
		ifTrue: [nextActionTime _ self nextAnimationActionTime]! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/20/2000 00:02'!
nextAnimationActionTime
	^(nextActions isEmptyOrNil
		ifTrue: [self stepTime]
		ifFalse: [nextActions first last]) + Time millisecondClockValue! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/19/2000 23:33'!
random
	^random! !

!ChickenEyes methodsFor: 'private' stamp: 'mir 10/19/2000 22:21'!
resetActions
	nextActions _ OrderedCollection new! !


!ChickenEyes class methodsFor: 'documentation'!
documentation
"
    like xeyes, but cuter ...

    [start with:]
        Demos::ChickenEyes open

    [see also:]
        Demos::ChickenFun
        moorhuhn ;-)
"

! !

!ChickenEyes class methodsFor: 'documentation'!
examples
"
                                                                [exBegin]
        Demos::ChickenEyes open
                                                                [exEnd]
"
! !

!ChickenEyes class methodsFor: 'documentation'!
version
    ^ '$Header: /files/CVS/stx/clients/Demos/ChickenEyes.st,v 1.11 2000/09/06 14:20:53 cg Exp $'
! !

!ChickenEyes class methodsFor: 'class initialization' stamp: 'mir 10/20/2000 00:29'!
initialize
	"ChickenEyes initialize"

	self readImages! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
blinkImages
	^BlinkImages! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
comeImages
	^ComeImages! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
extractSequence: aSequence from: images
	^aSequence collect: [:index | images at: index]! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
holeImages
	^HoleImages! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
lookForwardImage
	^FwdImage! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
lookImages
	^LookImages! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/19/2000 21:20'!
pickImages
	^PickImages! !

!ChickenEyes class methodsFor: 'images' stamp: 'mir 10/20/2000 00:30'!
readImages
	| imageDir fileNames |
	"ChickenEyes readImages"

	imageDir := FileDirectory on: (FileDirectory default fullNameFor: ('chicken', FileDirectory slash , 'images')).

	ComeImages := OrderedCollection new: 20.
	fileNames _ (imageDir fileNamesMatching: 'come*.gif') asSortedCollection.
	fileNames do: [:fileName | ComeImages add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: fileName))].

	HoleImages := OrderedCollection new: 20.
	fileNames _ (imageDir fileNamesMatching: 'hole*.gif') asSortedCollection.
	fileNames do: [:fileName | HoleImages add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: fileName))].

	LookImages := OrderedCollection new: 20.
	fileNames _ (imageDir fileNamesMatching: 'look0*.gif') asSortedCollection.
	fileNames do: [:fileName | LookImages add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: fileName))].

	FwdImage := GIFReadWriter formFromFileNamed: (imageDir fullNameFor: 'LookFwd.gif').

	BlinkImages := OrderedCollection new: 3.
	BlinkImages
		add: FwdImage;
		add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: 'Blink01.gif'));
		add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: 'Blink02.gif')).

	PickImages := OrderedCollection new: 2.
	PickImages
		add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: 'Pick01.gif'));
		add: (GIFReadWriter formFromFileNamed: (imageDir fullNameFor: 'Pick02.gif')).
! !

!ChickenEyes class methodsFor: 'startup'!
open
    |top v|

    top := StandardSystemView label:'Chicks-Eyes'.
    v := self new.
    v origin:0.0@0.0 corner:1.0@1.0.
    top addSubView:v.
    top extent:(v preferredExtent).
    top open.
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 22:33'!
blinkingSequence
	^(self blinkImages copyWith: self lookForwardImage) , self blinkImages reverse! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:25'!
chickenComingSequence
   ^self extractSequence: (6 to: 14) from: self comeImages
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:19'!
chickenGoingSequence
   ^self chickenComingSequence reverse
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:25'!
chickenLookAroundSequence
    "/ a quick look around ..."
    ^self extractSequence: (1 to: 5) from: self comeImages
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 22:04'!
chickenRandomLookAroundSequence
	| random sequenceLength sequence |
	random _ Random new.
	sequenceLength _ random nextInt: 12.
	sequence _ (1 to: sequenceLength) collect: [:ignore |
		random nextInt: self lookImages size].
	^self extractSequence: sequence from: self lookImages! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:19'!
closingHoleSequence
   ^self openingHoleSequence reverse! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 22:06'!
comeInSequence
    ^self openingHoleSequence ,    
    self chickenComingSequence ,
    self chickenLookAroundSequence
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:19'!
goAwaySequence
    ^self chickenGoingSequence , self closingHoleSequence
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:19'!
openingHoleSequence
   ^self extractSequence: (1 to: 5) from: self holeImages
! !

!ChickenEyes class methodsFor: 'sequences' stamp: 'mir 10/19/2000 21:19'!
pickSequence
    ^self pickImages! !

ChickenEyes initialize!
